=== debian/changelog ===
ulfius (2.5.2-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 26 Dec 2018 19:22:44 -0500

ulfius (2.5.1-2) unstable; urgency=medium

  * debian/*install: Add pkg-config file
  * debian/*install: multiarchify files

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 18 Dec 2018 12:40:54 -0500

ulfius (2.5.1-1) unstable; urgency=medium

  * New upstream release
  * Fix typo in extended description (Closes: #913616)
  * Override dh_auto_test
  * Add autopkgtest

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 15 Dec 2018 12:48:54 -0500
